/*	Filename:Main.cpp							*/
/************************************************/
/*												*/
/*			DSMP Lyrics Converter				*/
/*												*/
/*			DSMP̎t@Cϊc[			*/
/*												*/
/*					Ver.6.31   					*/
/*												*/
/*			CtH[W[			*/
/*                             					*/
/*		Copyright 1999,2003 by DELTA SOFT		*/
/*												*/
/************************************************/
/*
	Np[^
		DSMPLC.EXE [t@C [Qƃt@C|URL [o̓t@C]]]
*/
/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#include <vcl.h>
#include <shellapi.h>
#include <registry.hpp>
#include <IniFiles.hpp>
#include <Clipbrd.hpp>
#pragma hdrstop

#include "main.h"
#include "CRC32.h"
#include "Code.h"
#include "waitcur.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

#define	then
#define	AND	&&
#define	OR	||

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

TFormMain*	FormMain;
int			Version=6310;
int			TagVer=1000;
AnsiString	SepChr=" ,\t\"\'?!@ChfHI0123456789OPQRSTUVWX()ij[]mnuvwxyz>-+*/=|{^:;FG";
AnsiString	SepChr2=".)>]ACBD";

AnsiString	DSMPPath;
HWND		DSMPHandle;
UINT		WM_DSMP;

#define	DSMP_FIND				(WM_USER+1)
#define	DSMP_CLOSE				(WM_USER+2)
#define	DSMP_SETTOOL			(WM_USER+3)


/*----------------------------------------------*/
/*												*/
/*----------------------------------------------*/

/*****	񂩂當擾	*****/

int __fastcall	GetChar(char *p)
{
	unsigned char	*up=p;
	int		c;

	if (LeadBytes.Contains(*up))
	then	c=(*up<<8) | *(up+1);
	else	c=*up;

	return(c);
}

/*****	𕶎ɂ	*****/

AnsiString __fastcall	CharToStr(int c)
{
	char	bf[4];

	if (c>=0x100)
	then {												//2oCg
		bf[0]=(c>>8) & 0xFF;
		bf[1]=c & 0xFF;
		bf[2]=0;
	}
	else {
		bf[0]=c & 0xFF;
		bf[1]=0;
	}

	return(AnsiString(bf));
}

/*****	𕶎ɂ	*****/

AnsiString __fastcall	CharToStr(char *p)
{
	return(CharToStr(GetChar(p)));
}

/*****	DSMP.EXẼpX擾	*****/

AnsiString __fastcall	GetDSMPPath(void)
{
	DSMPPath="";

	TRegistry	*Reg=new TRegistry();
	Reg->RootKey=HKEY_LOCAL_MACHINE;
	if (Reg->OpenKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\DSMP.EXE",false))
	then {
		try {
			DSMPPath=Reg->ReadString("");
		}
		catch(...)
		{
			DSMPPath="";
		}
		Reg->CloseKey();
	}

	if (DSMPPath.IsEmpty())
	then {
		Reg->RootKey=HKEY_CURRENT_USER;
		if (Reg->OpenKey("Software\\DELTA\\DSMP",false))
		then {
			try {
				DSMPPath=Reg->ReadString("");
			}
			catch(...)
			{
				DSMPPath="";
			}
			Reg->CloseKey();
		}
	}
	delete	Reg;

	return(DSMPPath);
}

/*****	DSMP̃EBhEnh擾	*****/

HWND __fastcall	GetDSMPHandle(void)
{
	DSMPHandle=::FindWindow("TFormDSMP",NULL);
	if (DSMPHandle==0)
	then	DSMPHandle=::FindWindow("TDsmpForm",NULL);

	return(DSMPHandle);
}

/*****	DSMPɃ|Xg	*****/
/*
	DSMPɃNGXg𑗂
	ʂWM_DSMPőĂ
*/
bool __fastcall	PostDSMP(int Command,int WParam,int LParam)
{
	if (DSMPHandle==0)
	then {
		if (GetDSMPHandle()==0)
		then	return(false);
	}

	return(::PostMessage(DSMPHandle,Command,WParam,LParam));
}

/*****	c[ݒ肷	*****/

void __fastcall	SetDSMPTool(AnsiString Name,AnsiString Command)
{
	AnsiString	S=GetDSMPPath();

	if (!S.IsEmpty())
	then {
		S=ChangeFileExt(S,".ini");
		TIniFile	*File=new TIniFile(S);

		File->WriteString("Tool",Name,Command);

		delete	File;

		PostDSMP(WM_DSMP,DSMP_SETTOOL,0);
	}
}

/*----------------------------------------------*/
/*				TFormMainNX					*/
/*----------------------------------------------*/

/*****	RXgN^	*****/

__fastcall TFormMain::TFormMain(TComponent* Owner)
	: TForm(Owner)
{
	AnsiString	S,s;

	S="DSMP Lyrics Converter Ver.";
	S+=FormatFloat("##.000",(double)Version/1000.0);
	FormMain->Caption=S;

	S=GetCurrentDir();

	OpenDialog->InitialDir=S;
	SaveDialog->InitialDir=S;

	WM_DSMP=::RegisterWindowMessage("WM_DSMP");			//WM_DSMP擾
	GetDSMPPath();
	GetDSMPHandle();

	FHtml=new dsvHtml();

	S=ChangeFileExt(Application->ExeName,".ini");
	TIniFile	*File=new TIniFile(S);

	Left=File->ReadInteger("DSMPLC","Left",-1);
	Top=File->ReadInteger("DSMPLC","Top",-1);
	Width=File->ReadInteger("DSMPLC","Width",480);
	Height=File->ReadInteger("DSMPLC","Height",350);
	if ((Width<0) OR (Width>=Screen->Width))
	then	Width=480;
	if ((Height<0) OR (Height>=Screen->Height))
	then	Height=350;
	if ((Left<0) OR (Left+Width>=Screen->Width))
	then	Left=(Screen->Width-Width)/2;
	if ((Top<0) OR (Top+Height>=Screen->Height))
	then	Top=(Screen->Height-Height)/2;

	S=File->ReadString("DSMPLC","OpenDir","");
	if (!S.IsEmpty())
	then	OpenDialog->InitialDir=S;
	S=File->ReadString("DSMPLC","SaveDir","");
	if (!S.IsEmpty())
	then	SaveDialog->InitialDir=S;

	delete	File;

	TRegistry	*Reg=new TRegistry();

	Reg->RootKey=HKEY_CLASSES_ROOT;
	if (Reg->OpenKey(".TagLyr",false)==false)
	then {
		MenuAssocTagLyrClick(this);
	}
	else {
		Reg->CloseKey();
	}
	if (Reg->OpenKey("DsmpTagFile",false)==false)
	then {
		MenuAssocTagLyrClick(this);
	}
	else {
		if (Reg->ValueExists("Converter")==false)
		then {
			Reg->CloseKey();
			MenuAssocTagLyrClick(this);
		}
		else {
			Reg->CloseKey();
			if (Reg->OpenKey("DsmpTagFile\\shell\\convert",false)==false)
			then {
				MenuAssocTagLyrClick(this);
			}
			else {
				Reg->CloseKey();
				if (Reg->OpenKey("DsmpTagFile\\shell\\open\\command",false))
				then {
					S="\""+Application->ExeName;
					S+="\" \"%1\"";
					if (S.AnsiCompareIC(Reg->ReadString(""))==0)
					then {
						MenuAssocTagLyr->Checked=true;
					}
					Reg->CloseKey();
				}
			}
		}
	}
	delete	Reg;

	S=ChangeFileExt(DSMPPath,".ini");
	File=new TIniFile(S);

	S=File->ReadString("Tool","DSMP Lyrics Converter","");
	s="\""+Application->ExeName;
	s+="\" /DSMP";
	if (S.AnsiCompareIC(s)==0)
	then	MenuSetDSMPTool->Checked=true;

	delete	File;


	::PostMessage(Edit->Handle,EM_SETMARGINS,EC_LEFTMARGIN,8);
}

/*****	TagLyrɊ֘At	****/

void __fastcall TFormMain::MenuAssocTagLyrClick(TObject *Sender)
{
	AnsiString	S,s;

	TRegistry	*Reg=new TRegistry();

	Reg->RootKey=HKEY_CLASSES_ROOT;
	if (Reg->OpenKey(".TagLyr",true)==false)			//Ȃ΍쐬
	then {
		delete	Reg;									//쐬łȂiG[j

		MenuAssocTagLyr->Checked=false;
		return;
	}
	try {
		Reg->WriteString("","DsmpTagFile");
		Reg->WriteString("Content Type","text/plain");
	}
	catch(...)
	{
	}
	Reg->CloseKey();

	if (Reg->OpenKey("DsmpTagFile",true)==false)		//Ȃ΍쐬
	then {
		delete	Reg;									//쐬łȂ

		MenuAssocTagLyr->Checked=false;
		return;
	}
	try {
		TLanguages*	Lang=Languages();
		if (Lang->IndexOf(0x0411)>=0)
		then	Reg->WriteString("","DSMP ^Ot@C");	//{
		else	Reg->WriteString("","DSMP TagFile");		//̑
		Reg->WriteString("Converter",Application->ExeName);
		Reg->CloseKey();

		Reg->OpenKey("DsmpTagFile\\DefaultIcon",true);
		S=AnsiLowerCase(Reg->ReadString(""));
		s=AnsiLowerCase(ExtractFileName(Application->ExeName));
		if ((S.IsEmpty()) OR (S.AnsiPos(s)))
		then {
			if (DSMPPath.IsEmpty())
			then	S=Application->ExeName+",0";
			else	S=DSMPPath+",2";
			Reg->WriteString("",S);
		}
		Reg->CloseKey();

		Reg->OpenKey("DsmpTagFile\\shell",true);
		Reg->WriteString("","open");
		Reg->CloseKey();

		Reg->OpenKey("DsmpTagFile\\shell\\open",true);
		if (Lang->IndexOf(0x0411)>=0)
		then	Reg->WriteString("","J(&O)");
		else	Reg->WriteString("","&Open");
		Reg->CloseKey();

		Reg->OpenKey("DsmpTagFile\\shell\\open\\command",true);
		S="\""+Application->ExeName;
		S+="\" \"%1\"";
		Reg->WriteString("",S);
		Reg->CloseKey();

		Reg->OpenKey("DsmpTagFile\\shell\\convert",true);
		if (Lang->IndexOf(0x0411)>=0)
		then	Reg->WriteString("","ϊ");
		else	Reg->WriteString("","Convert");
		Reg->CloseKey();

		Reg->OpenKey("DsmpTagFile\\shell\\convert\\command",true);
		S="\""+Application->ExeName;
		S+="\" -convert \"%1\"";
		Reg->WriteString("",S);
		Reg->CloseKey();
	}
	catch(...)
	{
	}
	delete	Reg;

	MenuAssocTagLyr->Checked=true;
}

/*****	DSMPɃc[o^	*****/

void __fastcall TFormMain::MenuSetDSMPToolClick(TObject *Sender)
{
	AnsiString	S="\""+Application->ExeName;
	S+="\" /DSMP";
	SetDSMPTool("DSMP Lyrics Converter",S);
	MenuSetDSMPTool->Checked=true;
}

/*****	tH[N[Y	*****/

void __fastcall TFormMain::FormClose(TObject *Sender, TCloseAction &Action)
{
	AnsiString	S=ChangeFileExt(Application->ExeName,".ini");

	TIniFile	*File=new TIniFile(S);

	File->WriteInteger("DSMPLC","Left",Left);
	File->WriteInteger("DSMPLC","Top",Top);
	File->WriteInteger("DSMPLC","Width",Width);
	File->WriteInteger("DSMPLC","Height",Height);
	File->WriteString("DSMPLC","OpenDir",OpenDialog->InitialDir);
	File->WriteString("DSMPLC","SaveDir",SaveDialog->InitialDir);

	delete	File;

	delete	FHtml;
}

/*****	N[Y₢킹	****/

void __fastcall TFormMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	if (Edit->Modified)
	then {
		AnsiString	S=ExtractFileName(FFileName);
		S+="ۑ܂H";
		int	Res=MessageDlg(S,mtConfirmation,TMsgDlgButtons()<<mbYes<<mbNo<<mbCancel,0);
		if (Res==mrCancel)
		then	CanClose=false;
		else if (Res==mrYes)
		then {
			MenuSaveAsClick(this);
		}
	}
}

/*****	EBhE쐬p[^̐ݒ	*****/
/*
	DRAG&DROP󂯕t̕@
	Window쐬̃p[^WS_EX_ACCEPTFILESݒ肷
	̂߂CreatParamsI[o[Ch
*/
void __fastcall TFormMain::CreateParams(Controls::TCreateParams &Params)
{
	inherited::CreateParams(Params);				//e(TForm)CreateParamsĂŃp[^쐬

	Params.ExStyle |=WS_EX_ACCEPTFILES;				//hbvt@C󂯕t悤ɂ
}

/*****	tH[\ꂽ	*****/
/*
	DRAG&DROP󂯕t̕@
	Windows API::DragAcceptFiles()g
	ȂÂQ̕@͂ǂ炩ŏ\ł
*/
void __fastcall TFormMain::FormShow(TObject *Sender)
{
	int		i;
	bool	fDSMPCall=false;
	bool	fConvert=false;
	bool	fOpen=false;							//trueɂǁc
	AnsiString	S,FileName;

//	::DragAcceptFiles(Handle,true);					//hbvt@C󂯕t悤ɂ

	for(i=1;	i<=ParamCount();	i++)
	{
		S=ParamStr(i);
		if ((!S.IsEmpty()) AND (S[1]=='/'))
		then	S[1]='-';

		if (S.AnsiCompareIC("-dsmp")==0)
		then	fDSMPCall=true;
		if (S.AnsiCompareIC("-convert")==0)
		then	fConvert=true;
		if (S.AnsiCompareIC("-noopen")==0)
		then	fOpen=false;
		else if ((!S.IsEmpty()) AND (S[1] != '/') AND (S[1] != '-'))
		then {
			if (FileName.IsEmpty())
			then	FileName=S;
			else if (FRefFileName.IsEmpty())
			then	FRefFileName=S;
			else if (FOutFileName.IsEmpty())
			then	FOutFileName=S;
		}
	}

	FError=0;
	if (!FileName.IsEmpty())
	then {
		bool	opened=false;

		Load(FileName);

		if (fConvert)
		then {
			if (FRefFileName.IsEmpty())
			then {
				FRefFileName=Edit->Lines->Values["URL"];

				if ((fOpen) AND (!FRefFileName.IsEmpty()))
				then {
					OpenURL(FRefFileName);
					opened=true;
				}

/*RgAEgƏo̓t@C₢킹Ȃ

				if (FOutFileName.IsEmpty())
				then {
					S=ExtractFileName(Edit->Lines->Values["LyrFile"]);
					if (!S.IsEmpty())
					then {
						FOutFileName=ExtractFilePath(FFileName);
						FOutFileName+=S;
					}
				}
*/
			}
		}
		if (!FRefFileName.IsEmpty())
		then {
			::PostMessage(Handle,WM_DSMPLC_CONVERT,opened,0);		//bZ[W[v񂷂
		}
	}
}

/*****	WM_DSMPLC_CONVERT	*****/

void __fastcall	TFormMain::WMConvert(TMessage &Msg)
{
	if ((FError==0) AND (!FRefFileName.IsEmpty()))
	then {
		AnsiString	CurDir=GetCurrentDir();
		SetCurrentDir(ExtractFileDir(FFileName));

		if (AnsiLowerCase(ExtractFileExt(FFileName))==".taglyr")
		then	TagToDSMP(FRefFileName);
		else	DSMPToTag(FRefFileName);

		if (Msg.WParam)									//Open(ULR)ꍇ
		then	BringToFront();

		if (FError==0)
		then {
			if (!FOutFileName.IsEmpty())
			then	Save(FOutFileName);
			else	MenuSaveAsClick(this);
		}
		SetCurrentDir(CurDir);
	}
	Close();
}

/*****	t@Chbvꂽ	*****/

void __fastcall TFormMain::WMDropFiles(TWMDropFiles& Msg)
{
	int			DropCount=::DragQueryFile((void*)(Msg.Drop),0xFFFFFFFF,NULL,0);	//hbvꂽt@C̐
	char		*bf=new char[MAX_PATH+16];										//t@C擾pobt@
	AnsiString	S,s;
	int			i;

	::DragQueryFile((void*)(Msg.Drop),0,bf,MAX_PATH+16);		//t@C擾
	S=bf;
	s=AnsiLowerCase(ExtractFileExt(S));
	if ((Edit->Lines->Count) AND ((s==".htm") OR (s==".html") OR (s==".txt")))
	then {
		int	res=MessageDlg("^Ot@Cϊ܂H",mtConfirmation,TMsgDlgButtons()<<mbYes<<mbNo<<mbCancel,0);

		if (res==mrYes)
		then {
			if (AnsiLowerCase(ExtractFileExt(FFileName))==".taglyr")
			then	TagToDSMP(S);
			else	DSMPToTag(S);
		}
		else if (res==mrNo)
		then {
			Load(S);													//[h
			OpenDialog->InitialDir=ExtractFileDir(FFileName);
		}
	}
	else {
		Load(S);													//[h
		OpenDialog->InitialDir=ExtractFileDir(FFileName);
	}
	::DragFinish((void*)(Msg.Drop));					//D&DIʒm
	delete	bf;

	Msg.Result=0;										//bZ[W
}

/*****	LvVݒ	*****/

void __fastcall	TFormMain::SetCaption(AnsiString FileName)
{
	FFileName=FileName;
	FileName=ExtractFileName(FileName);
	FormMain->Caption=FileName;						//^Cgo[Ƀt@C\
}

/*****	Load HTML	*****/

void __fastcall	TFormMain::LoadHtml(AnsiString FileName)
{
	dsvHtml	*FHtml=new dsvHtml();

	TStringList		*SList=new TStringList();

	FHtml->Load(FileName,SList);							//[hSJISCodeϊ

	AnsiString	S=ChangeFileExt(FileName,".txtmp");
	FHtml->SaveText(S,SList);								//^OeLXgZ[u
	Edit->Lines->LoadFromFile(S);							//eLXg[h

	DeleteFile(S);

	delete	SList;
	delete	FHtml;
}

/*****	[h	*****/

void __fastcall	TFormMain::Load(AnsiString FileName)
{
	dsWaitCursor	csr;

	FError=0;
	Edit->Clear();

	if (FileExists(FileName)==false)
	then {
		FError=ERROR_FILE_NOT_FOUND;
		MessageDlg(FileName+"Ft@C܂",mtError,TMsgDlgButtons()<<mbOK,0);
		return;
	}

	FLoadFileName=FileName;						//[ht@C

	SetCaption(FileName);						//^Cgo[Ƀt@C\

	AnsiString	S=AnsiLowerCase(ExtractFileExt(FileName));
	if ((S==".htm") OR (S==".html"))
	then {
		LoadHtml(FileName);
	}
	else {
		Edit->Lines->LoadFromFile(FileName);
	}

	Edit->Modified=false;
}

/*****	Z[u	*****/

void __fastcall	TFormMain::Save(AnsiString FileName)
{
	dsWaitCursor	csr;

	SetCaption(FileName);									//^Cgo[Ƀt@C\

	Edit->Lines->SaveToFile(FileName);
	Edit->Modified=false;
}

/*****	[Spec]ZNV̑}	*****/

int __fastcall	TFormMain::InsertSpecSection(void)
{
	Edit->Lines->Insert(0,"[Spec]");
	Edit->Lines->Insert(1,"Title=");
	Edit->Lines->Insert(2,"Artist=");
	Edit->Lines->Insert(3,"Lyrics=");
	Edit->Lines->Insert(4,"Music=");
	Edit->Lines->Insert(5,"Presenter=");
	Edit->Lines->Insert(6,"Comment=");
	Edit->Lines->Insert(7,"");
	Edit->Lines->Insert(8,"Size=246,38");
	Edit->Lines->Insert(9,"Adjust=0");
	Edit->Lines->Insert(10,"Font=\"lr oSVbN\",-16,SHIFTJIS,Normal");
	Edit->Lines->Insert(11,"Alignment=Center");
	Edit->Lines->Insert(12,"WordWrap=1");
	Edit->Lines->Insert(13,"");

	Edit->Lines->Insert(14,"[Text]");

	Edit->Modified=true;

	return(15);
}

/*****	ʒu(x,y)ϊ	*****/
/*
	Index0x[X
*/
TPoint __fastcall	TFormMain::IndexToPoint(int Index)
{
	TPoint	P;

	P.x=Index;
	for(P.y=0;	P.y<Edit->Lines->Count;	P.y++)
	{
		if (P.x<Lines[P.y].Length()+2)					//+2\r\n̕
		then	break;
		P.x-=Lines[P.y].Length()+2;
	}
	return(P);
}

/*****	(x,y)ʒu	*****/

int __fastcall	TFormMain::PointToIndex(int x,int y)
{
	int		i;
	int		n=x;

	for(i=0;	i<y;	i++)
	{
		n+=Lines[i].Length()+2;
	}

	return(n);
}

/*****	J[\ݒ肷	*****/

void __fastcall	TFormMain::SetCursor(int x,int y)
{
	Edit->SelStart=PointToIndex(x,y);
	Edit->SetFocus();
	::PostMessage(Edit->Handle,EM_SCROLLCARET,0,0);
}

/*****	J[\̂sԍ擾	*****/

int __fastcall	TFormMain::GetCursorLineNo(void)
{
	int		line=Edit->CaretPos.y;
	AnsiString	S=Edit->SelText;
	if (S=="\r\n")
	then	line--;

	return(line);
}

/*****	sݒ肷	*****/

void __fastcall	TFormMain::SetLine(int line,AnsiString S)
{
	if (line<0)
	then	line=GetCursorLineNo();

	Edit->Lines->Strings[line]=S;
}

/*****	s擾	*****/

AnsiString __fastcall	TFormMain::GetLine(int line)
{
	if (line<0)
	then	line=GetCursorLineNo();

	return(Edit->Lines->Strings[line]);
}

/*****	J[\̂s擾	*****/

AnsiString __fastcall	TFormMain::GetCursorLine(void)
{
	return(GetLine(-1));
}

/*****	Is擾	*****/

int	__fastcall	TFormMain::GetSelectLine(int &From,int &To)
{
	TPoint	P;

	P=IndexToPoint(Edit->SelStart);
	From=P.y;
	if (Edit->SelLength)
	then {
		P=IndexToPoint(Edit->SelStart+Edit->SelLength-1);
		To=P.y;
	}
	else {
		To=From;
	}

	return(Edit->SelStart);
}

/*****	seLXg擾	*****/
/*
	߂l͎
	FQuotefalseȂ""͎ĕԂ
*/
int __fastcall	TFormMain::ExtractText(AnsiString S,AnsiString &Text)
{
	int	Time=StrToTime(S);

	Text=S;
	if (Time>=0)
	then {
		int		n=Text.AnsiPos("=");
		if (n)
		then {
			Text=Text.SubString(n+1,Text.Length()-n+1);
			if (FQuote==false)
			then	Text=ExtractQuotedString(Text);
		}
		else	Time=-1;
	}

	return(Time);
}

/*****	sԂƃeLXgɕĎ擾	*****/
/*
	߂l͍sԍ
	""͎ĕԂ
*/
int __fastcall	TFormMain::ExtractLine(int n,AnsiString &Time,AnsiString &Text)
{
	if (n<0)
	then	n=GetCursorLineNo();

	Time=Edit->Lines->Names[n];
	Text=Lines[n];
	if (!Time.IsEmpty())
	then {
		AnsiString	S;
		if (StrToTime(Time)>=0)
		then {
			int	n=Text.AnsiPos("=");
			if (n)
			then {
				Text=Text.SubString(n+1,Text.Length()-n+1);
				if (FQuote==false)
				then	Text=ExtractQuotedString(Text);
			}
			else	Time="";
		}
		else {
			Time="";
		}
	}

	return(n);
}

/*****	Xy[Xǂݔ΂	*****/

char* __fastcall	TFormMain::SkipSpace(char *p)
{
	while((*p==' ') OR (*p=='\t'))
	{
		p++;
	}
	return(p);
}

/*****	s؂CR(0x0D)ɂ	*****/

AnsiString __fastcall	TFormMain::CommaToCR(AnsiString S)
{
	char	*p=S.c_str();
	char	*q=p;
	char	*r;

	while(p)
	{
		p=AnsiStrScan(p,'\"');
		if (p)
		then {
			p=SkipSpace(p+1);
			if (*p==',')
			then {
				r=p;
				p=SkipSpace(p+1);
				if (*p=='\"')
				then {
					S[r-q+1]='\r';					//*p++='\r'ł͌܂ŕύXĂ܂
				}
			}
		}
	}

	return(S);
}

/*****	OɃXy[X鎞""Ŋ	*****/

AnsiString __fastcall	TFormMain::QuotedString(AnsiString S)
{
	char	*p=S.AnsiLastChar();
	int		n=S.Length();
	if (((n) AND (S[1]==' '))
		OR ((p) AND (*p==' '))
		OR ((n>=2) AND ((unsigned char)S[1]==0x81) AND (S[2]==0x40))	  	//sSpXy[X
		OR ((n>=2) AND ((unsigned char)S[n-1]==0x81) AND (S[n]==0x40)))		//sSpXy[X
	then	S=AnsiQuotedStr(S,'\"');

	return(S);
}

/*****	""ŊĂ	*****/

AnsiString __fastcall	TFormMain::ExtractQuotedStr(AnsiString S)
{
	char	*p=S.c_str();
	if ((p) AND (*p=='\"') AND (*(S.AnsiLastChar())=='\"'))
	then {
		S=S.SubString(2,S.Length()-2);
		S=StringReplace(S,"\"\"","\"",TReplaceFlags()<<rfReplaceAll);
//		S=AnsiExtractQuotedStr(p,'\"');
	}
	return(S);
}

/*****	""ŊĂ	*****/

AnsiString __fastcall	TFormMain::ExtractQuotedString(AnsiString Text)
{
	AnsiString	S=CommaToCR(Text);
	if (S.AnsiPos("\r"))								//s͂̂܂ܕԂ
	then	return(Text);

	S=ExtractQuotedStr(Text);

	return(S);
}

/*****	ԂƃeLXgs	*****/

AnsiString __fastcall	TFormMain::MakeLine(int ms,TStringList *SList)
{
	AnsiString	S,Text;
//	char		*p;
	int			i;

	for(i=0;	i<SList->Count;	i++)
	{
		S=SList->Strings[i];
//		p=S.AnsiLastChar();
		if (SList->Count>=2)
		then {
			S=AnsiQuotedStr(S,'\"');
//			if ((S.Length()==0) OR (p==NULL) OR (S[1] !='\"') OR (*p != '\"'))
//			then	S=AnsiQuotedStr(S,'\"');
		}
		S=QuotedString(S);
		if (!Text.IsEmpty())
		then	Text+=",";
		Text+=S;
	}
	S=TimeToStr(ms);
	S+="=";
	S+=Text;

	return(S);
}

/*****	ԂƃeLXgs	*****/

AnsiString __fastcall	TFormMain::MakeLine(int ms,AnsiString Text)
{
	if (ms<0)
	then	return(Text);

	AnsiString	S=TimeToStr(ms);

	S+="=";
	S+=QuotedString(Text);

	return(S);
}

/*****	ԁimsjɕϊ	*****/

int __fastcall	TFormMain::StrToTime(AnsiString Time)
{
	int		ms;
	int		n;
	AnsiString	S;

	Time=Time.Trim();
	if ((Time.Length()==0) OR (Time[1]==';'))
	then	return(-1);

	n=Time.AnsiPos("=");
	if (n)
	then	Time=Time.SubString(1,n-1);
	n=Time.AnsiPos(":");
	if (n)
	then {
		S=Time.SubString(1,n-1);
		ms=S.ToIntDef(0);
		Time=Time.SubString(n+1,Time.Length()-n);
		n=Time.AnsiPos(":");
		if (n)
		then {
			S=Time.SubString(1,n-1);
			ms=(ms*60+S.ToIntDef(0))*1000;
			Time=Time.SubString(n+1,Time.Length()-n);
			ms+=Time.ToIntDef(0);
		}
		else	ms=(ms*60+Time.ToIntDef(0))*1000;	   		//m:š`
	}
	else	ms=S.ToIntDef(-1);								//mš`

	return(ms);
}

/*****	ԁimsj𕶎ɕϊ	*****/

AnsiString __fastcall	TFormMain::TimeToStr(int ms)
{
	int		s=ms/1000;
	int		m=s/60;
			s=s%60;
			ms=ms%1000;

	AnsiString	S=Format("%.2d:%.2d:%.3d",OPENARRAY(TVarRec,((m),(s),(ms))));

	return(S);
}

/*****	Is̎Ԃݒ肷	*****/

void __fastcall	TFormMain::SetTimes(int Step,int add)
{
	AnsiString	Time;
	AnsiString	S;
	int			From,To;
	int			i,ms;

	GetSelectLine(From,To);

	ExtractLine(From,Time,S);
	ms=StrToTime(Time);
	if ((ms<0) OR (Step==0))
	then	ms=0;

	FQuote=true;								//""͕t܂܎擾
	for(i=From;	i<=To;	i++)
	{
		ExtractLine(i,Time,S);
		if (add)
		then {
			ms=StrToTime(Time);
			ms+=add;
			if (ms<0)
			then	ms=0;
			S=MakeLine(ms,S);
		}
		else {
			if (Text.AnsiPos("="))
			then	S=MakeLine(ms-1,S);
			else {
				S=MakeLine(ms,S);
				ms+=Step;
			}
		}
		Lines[i]=S;
	}
	FQuote=false;

	Edit->Modified=true;
}

/*****	ss̃Xy[X폜	*****/

AnsiString __fastcall TFormMain::DeleteSpace(AnsiString S)
{
	int		n;

	S=ExtractQuotedString(S);
L1:
	S=S.Trim();
	n=S.Length();
	if (n>=2)
	then {
		if (((unsigned char)S[1]==0x81) AND (S[2]==0x40))			//s̑SpXy[XJbg
		then {
			S=S.SubString(3,S.Length()-2);
			goto L1;
		}
		else if (((unsigned char)S[n-1]==0x81) AND (S[n]==0x40))   	//Ō̑SpXy[XJbg
		then {
			S=S.SubString(1,S.Length()-2);
			goto L1;
		}
	}
	return(S);
}

/*****	ss̃Xy[X폜	*****/

void __fastcall TFormMain::DeleteSpace(void)
{
	AnsiString	S;
	int			ms,From,To;
	int			i,j;
	TStringList	*SList=new TStringList();

	FQuote=false;

	GetSelectLine(From,To);

	for(i=From;	i<=To;	i++)
	{
		ms=ExtractText(Lines[i],S);
		if ((ms<0) OR (S.IsEmpty()))
		then	continue;
		SList->Text=CommaToCR(S);
		for(j=0;	j<SList->Count;	j++)
		{
			SList->Strings[j]=DeleteSpace(SList->Strings[j]);
		}
		Lines[i]=MakeLine(ms,SList);
	}

	delete	SList;
}

/*****	TextDSMP	*****/

void __fastcall	TFormMain::TextToDSMP(void)
{
	dsWaitCursor	wcsr;
	AnsiString	S;
	int			i;

	Edit->ClearUndo();

	for(i=0;	i<Edit->Lines->Count;	i++)
	{
		S=Lines[i];
		Lines[i]=S.Trim();
	}

	Edit->SelectAll();
	SetTimes(0);
	Edit->SelectAll();
	DeleteSpace();

	InsertSpecSection();

	if (!FFileName.IsEmpty())
	then {
		FFileName=ChangeFileExt(FFileName,".lyr");
		SetCaption(FFileName);
	}
}

/*****	DSMPText	*****/

void __fastcall	TFormMain::DSMPToText(void)
{
	AnsiString	S;
	int			i,j,n;

	Edit->ClearUndo();

	TStringList	*SList=new TStringList();
	SList->Text=Edit->Text;
	TStringList	*slist=new TStringList();

	Edit->Clear();
    n=0;

	for(i=0;	i<SList->Count;	i++)
	{
		if (AnsiLowerCase(SList->Strings[i])=="[text]")
		then	break;
	}
	i++;
	FQuote=true;
	for(;	i<SList->Count;	i++)
	{
		ExtractText(SList->Strings[i],S);
		if (S.IsEmpty())
		then	Edit->Lines->Insert(n++,"");
		else {
			slist->Text=CommaToCR(S);
			for(j=0;	j<slist->Count;	j++)
			{
				Edit->Lines->Insert(n++,ExtractQuotedString(slist->Strings[j]));
			}
		}
	}

	delete	slist;
	delete	SList;
}

/*****	WinAmpDSMP	*****/

void __fastcall	TFormMain::WinAmpToDSMP(void)
{
	dsWaitCursor	csr;
	AnsiString		S,s;
	AnsiString		C;
	int				i,j,n;

	if (Edit->Lines->Count==0)						//Ȃ烊^[
	then	return;

	S=Edit->Lines->Strings[0];						//n߂̍s肾
	S=S.LowerCase();								//pɕϊ
	if (S=="[spec]")                                //[spec]ZNVΕϊς
	then	return;

/*------	WinAmpp̉̎t@CDSMP̌`ɕϊ	-----*/

	Edit->ClearUndo();

	for(i=0;	i<Edit->Lines->Count;	i++)
	{
		S=Edit->Lines->Strings[i];					//1s肾
		S=S.Trim();									//擪Ɩ̋󔒂폜
		if (S.IsEmpty())							//󕶎Ȃ玟̍s
		then	continue;
		C=";"+S;									//Rgsɂ
		if (S[1]=='[')								//'['Ŏn܂Εϊ
		then {
			if (S=="[[[Music Info]]]")				//g̓T|[gȂ
			then	C="";
			else if ((S.Length()>=2) AND (isdigit(S[2])))	//'['̏ꍇ
			then {
				n=S.AnsiPos("]");						//']'̈ʒu擾
				if (n>=2)
				then {
					C=S.SubString(2,n-2);				//^Co
					j=C.AnsiPos(":");					//[mm:ss][mm:ss:ms]𔻒
					if (j)
					then {
						s=C.c_str()+j;
						j=s.AnsiPos(":");				//[mm:ss:ms]̏ꍇ
						if (j)
						then {
							C+="0";						//WinAmp1/100bȂ̂'0't
						}
					}
					C+="=";								//"="t
					C+=S.SubString(n+1,S.Length()-n);	//̎o
				}
			}
		}
		Edit->Lines->Strings[i]=C;						//ϊʂɒu
	}

/*-----	DSMP[Spec]ZNVǉ	-----*/

	InsertSpecSection();

	FFileName=ChangeFileExt(FFileName,".lyr");
	SetCaption(FFileName);
}

/*****	QƕCK	*****/

bool __fastcall	TFormMain::CheckLinkString(AnsiString S,int len,int sc,unsigned long crc)
{
	if ((len==0) OR (sc==0))
	then	return(true);

	if (S.Length() != len)
	then	return(false);

	char	*p=S.c_str();
	if (p==NULL)
	then	return(false);

	int		c=GetChar(p);
	if (c != sc)											//擪CK
	then	return(false);

	if (CRC32(0,p,len) != crc)
	then	return(false);

	return(true);
}

/*****	QƃeLXg	*****/

AnsiString __fastcall	TFormMain::FindText(AnsiString Text,int n,int Len,AnsiString s1,unsigned long crc)
{
	unsigned char	*p,*p0,*p1,*p2;
	int	TextLen;

	int		c=GetChar(s1.c_str());

	AnsiString	S=Text.SubString(n,Len);

	if (CheckLinkString(S,Len,c,crc)==false)
	then {
		TextLen=Text.Length();
		p0=Text.c_str();
		p1=p0;
		p2=s1.c_str();
		try {
			while((p1) AND (p1<p0+TextLen) AND (*p1))
			{
				p1=AnsiStrPos(p1,p2);
				if (p1==NULL)
				then	break;
				S=Text.SubString(p1-p0+1,Len);
				if (CheckLinkString(S,Len,c,crc))
				then	break;
				if (c>=0x100)
				then	p1+=2;
				else	p1++;
			}
			if ((p1==NULL) OR (p1>=p0+TextLen) OR (*p1==0))		//Ȃ
			then {
				S="";
			}
		}
		catch(...)
		{
			S="";
		}
	}

	return(S);
}

/*****	Download	*****/

bool __fastcall	TFormMain::Download(AnsiString URL,AnsiString Path)
{
	AnsiString	S=URL+"ɐڑ...";
	StatusBar->SimpleText=S;

/*
	TWinInet	*WinInet=new TWinInet();
	bool	f=WinInet->Download(URL,Path);
	delete	WinInet;
*/
	TDownloadThread	*Download=new TDownloadThread();
	Download->OnProgress=DownloadOnProgress;
	bool	f=Download->Download(URL,Path);
	delete	Download;

	StatusBar->SimpleText="";
	if (f==false)
	then {
		DeleteFile(Path);
		FError=ERROR_INVALID_ACCESS;
		MessageDlg(URL+"\r\ny[W擾ł܂ł",mtError,TMsgDlgButtons()<<mbOK,0);

		return(false);
	}
	return(true);
}

/*****	TAGDSMP	*****/

bool __fastcall	TFormMain::TagToDSMP(AnsiString Reference)
{
	dsWaitCursor	wcsr;

	bool			fDownload=false;
	AnsiString		FileName;
	AnsiString		text;
	AnsiString		S,s,s1,s2;
	unsigned char	*p,*p1,*p2,*p3;
	int				Line,ms,len,n,c,c2,i,fi;
	unsigned long	crc;

	AnsiString		Text,HankakuText,ZenkakuText;
	AnsiString		Html,HankakuHtml,ZenkakuHtml;

//	FEsc=false;

	S=Reference.LowerCase();
	if (S.AnsiPos("http:"))
	then {
		fDownload=true;

		S=CheckUtaNet(Reference);
		
		Reference=ExtractFilePath(Application->ExeName);
		Reference+="Reference.htm";

		if (Download(S,Reference)==false)
		then	return(false);
	}

	if (FileExists(Reference)==false)
	then {
		StatusBar->SimpleText="";
		FError=ERROR_FILE_NOT_FOUND;
		MessageDlg(Reference+"Ft@C܂",mtError,TMsgDlgButtons()<<mbOK,0);
		return(false);
	}

	Edit->ClearUndo();

	TStringList	*SList=new TStringList();

	StatusBar->SimpleText=FFileName+"ϊ...";
	s=AnsiLowerCase(ExtractFileExt(Reference));
	if ((s==".htm") OR (s==".html"))
	then {
		TStringList		*HtmlList=new TStringList();

		FHtml->Load(Reference,HtmlList);

		S=ChangeFileExt(Reference,".txtmp");
		FHtml->SaveText(S,HtmlList);
		SList->LoadFromFile(S);
		Text=SList->Text;
		DeleteFile(S);

		if (FHtml->CodeSet != csSJIS)
		then {
			S=ChangeFileExt(Reference,".htmltmp");
			FHtml->Save(S,HtmlList);
			HtmlList->LoadFromFile(S);
			DeleteFile(S);
		}
		else {
			HtmlList->LoadFromFile(Reference);
		}
		Html=HtmlList->Text;
		delete	HtmlList;
	}
	else {
		SList->LoadFromFile(Reference);
		Text=SList->Text;
	}
	if (fDownload)
	then {
		DeleteFile(Reference);

		if (Text.AnsiPos("ύݍĂ܂"))
		then {
			MessageDlg("TCgGĂ܂\r\nĎsĂ",mtWarning,TMsgDlgButtons()<<mbOK,0);
			delete	SList;
			return(false);
		}
	}

	HankakuText=ZenToHan(Text);
	ZenkakuText=HanToZen(Text);
	HankakuHtml=ZenToHan(Html);
	ZenkakuHtml=HanToZen(Html);

	FileName=ChangeFileExt(FFileName,".lyr");

	S=GetLine(0);
	S=S.LowerCase();
	if (S=="[taglyr]")
	then {
		S=Edit->Lines->Values["LyrFile"];
		if (!S.IsEmpty())
		then	FileName=S;

		while(Edit->Lines->Count)
		{
			S=GetLine(0);
			S=S.LowerCase();
			if (S=="[spec]")
			then break;
			Edit->Lines->Delete(0);
		}
	}

	AnsiString	Lines;

	FQuote=false;
	for(Line=0;	Line<Edit->Lines->Count;	Line++)
	{
		S=GetLine(Line);
		Lines+=S;
		Lines+="\r\n";
		s=S.LowerCase();
		if (s=="[text]")
		then	break;
	}
	for(Line++;	Line<Edit->Lines->Count;	Line++)
	{
		if ((Line & 0x0F)==0)
		then {
			SetCursor(0,Line);
			Application->ProcessMessages();
		}
//		if (FEsc)
//		then	break;

		text=GetLine(Line);
		if (text.IsEmpty())
		then {
			Lines+=text;
			Lines+="\r\n";
			continue;
		}
		p=text.c_str();
		S="";
		while(*p)
		{
			if (*p != '<')
			then {
				S+=CharToStr((char*)p);
				if (LeadBytes.Contains(*p))
				then	p+=2;
				else	p++;
				continue;
			}
			p++;
			p2=p;
			while(*p2)
			{
				if (*p2=='>')
				then	break;
				p2++;
			}
			n=p2-p;
			if (*p2==0)
			then {
				S+=(char*)(p-1);
				p=p2;
				continue;
			}
			if (n==0)
			then {
				S+="<";
				p=p2+1;
				continue;
			}
			s2=text.SubString((p-text.c_str())+1,n);
			SList->CommaText=s2;
			p=p2+1;
			if (SList->Count==1)
			then	SList->Add("0");
			while(SList->Count<4)
			{
				SList->Add("");
			}
			n=SList->Strings[0].ToIntDef(0);				//ʒu
			len=SList->Strings[1].ToIntDef(0);				//
			if ((n==0) OR (len<1))
			then {
				S+=s2;
				continue;
			}
			s1=SList->Strings[2];							//擪
//			c2=GetChar(s1.c_str());
			crc=SList->Strings[3].ToIntDef(0);				//CRC

			s=FindText(Text,n,len,s1,crc);
			if (s.IsEmpty())
			then {
				if (!Html.IsEmpty())
				then {
					s=FindText(Html,n,len,s1,crc);
				}
				if (s.IsEmpty())
				then {
					s=FindText(HankakuText,n,len,s1,crc);
					if (s.IsEmpty())
					then {
						s=FindText(ZenkakuText,n,len,s1,crc);
						if (s.IsEmpty())
						then {
							s=FindText(HankakuHtml,n,len,s1,crc);
							if (s.IsEmpty())
							then {
								s=FindText(ZenkakuHtml,n,len,s1,crc);

								if (s.IsEmpty())
								then {
									s="<";
									s+=s2;
									s+=">";
								FError=ERROR_INVALID_DATA;
								}
							}
						}
					}
				}
			}
			S+=s;
		}
//		Lines[Line]=S;
		Lines+=S;
		Lines+="\r\n";
	}
	delete	SList;

	Edit->Text=Lines;

	SetCursor(0,0);
	Edit->Invalidate();

	SetCaption(FileName);

	StatusBar->SimpleText="";

	if (FError)
	then {
		MessageDlg("ϊłȂ܂\r\nQƃt@CςĂ݂Ă\r\nTCgGĂ׃y[W擾łȂ\܂",mtWarning,TMsgDlgButtons()<<mbOK,0);
		return(false);
	}

	return(true);
}

/*****	_E[h OnProgress	*****/

void __fastcall	TFormMain::DownloadOnProgress(System::TObject* Sender,TDownloadStatus Status,DWORD Size)
{
	switch(Status)
	{
		case dsDownloading:
			StatusBar->SimpleText=Format("Downloading (%u bytes)",OPENARRAY(TVarRec,((int)Size)));
			break;
		case dsDisconnecting:
			StatusBar->SimpleText="Disconnecting";
			break;
	}

}

/*****	DSMPTAG	*****/

bool __fastcall	TFormMain::DSMPToTag(AnsiString Reference)
{
	dsWaitCursor	wcsr;

	AnsiString		URL;
	bool			fDownload=false;
	AnsiString		TagText;
	AnsiString		S,s,s1,s2,text;
	unsigned char	*p,*p2;
	int				Line,ms,len,l,n,c,c2,i;
	unsigned long	crc;
	int				ChrType;					//0=p,1=Sp
	int				ctype;

	FError=0;
	S=Reference.LowerCase();
	if (S.AnsiPos("http:"))
	then {
		fDownload=true;
		URL=Reference;
		Reference=ExtractFilePath(Application->ExeName);
		Reference+="Reference.htm";

		TWinInet	*WinInet=new TWinInet();
		bool	f=WinInet->Download(URL,Reference);
		delete	WinInet;

		if (f==false)
		then {
			if (URL.AnsiPos("//www.uta-net.com/phplib/"))
			then {
				TWinInet	*WinInet=new TWinInet();
				AnsiString	S=StringReplace(URL,"//www.uta-net.com/phplib/","//www.uta-net.com/members/phplib/",TReplaceFlags());
				f=WinInet->Download(S,Reference);
				delete	WinInet;
				if (f)
				then	URL=S;
			}
			if (f==false)
			then {
				DeleteFile(Reference);
				FError=ERROR_INVALID_ACCESS;
				MessageDlg(URL+"Fy[W擾ł܂ł",mtError,TMsgDlgButtons()<<mbOK,0);

				return(false);
			}
		}
	}

	if (FileExists(Reference)==false)
	then {
		FError=ERROR_FILE_NOT_FOUND;
		MessageDlg(Reference+"Ft@C܂",mtError,TMsgDlgButtons()<<mbOK,0);
		return(false);
	}

	Edit->ClearUndo();

	TStringList	*SList=new TStringList();

	s=AnsiLowerCase(ExtractFileExt(Reference));
	if ((s==".htm") OR (s==".html"))
	then {
		FHtml->Load(Reference,SList);
		text=ChangeFileExt(Reference,".txtmp");
		FHtml->SaveText(text,SList);

		if (URL.IsEmpty())
		then {
			for(i=0;	i<SList->Count;	i++)
			{
				S=SList->Strings[i];
				n=S.AnsiPos("<!-- saved from url=");
				if (n)
				then {
					n=S.AnsiPos("http:");
					if (n)
					then {
						URL=ExtractURL(S);
					}
					break;
				}
			}
		}
		SList->LoadFromFile(text);
		DeleteFile(text);
	}
	else {
		SList->LoadFromFile(Reference);
	}
	if (fDownload)
	then {
		DeleteFile(Reference);
	}

	Edit->Lines->Insert(0,"[TagLyr]");
	S="TagVer=";
	S+=TagVer;
	Edit->Lines->Insert(1,S);
	S="LyrFile=";
	S+=ExtractFileName(FFileName);
	Edit->Lines->Insert(2,S);
	S="Reference=";
	S+=ExtractFileName(Reference);
	Edit->Lines->Insert(3,S);
	if (!URL.IsEmpty())
	then {
		S="URL=";
		S+=URL;
		Edit->Lines->Insert(4,S);
		Edit->Lines->Insert(5,"");
	}
	else {
		Edit->Lines->Insert(4,"");
	}

	FQuote=false;
	for(Line=0;	Line<Edit->Lines->Count;	Line++)
	{
		S=GetLine(Line);
		TagText+=S;
		TagText+="\r\n";

		S=S.LowerCase();
		if (S=="[text]")
		then	break;
	}
	for(Line++;	Line<Edit->Lines->Count;	Line++)
	{
//		if (FEsc)
//		then	break;
		if ((Line & 0x0F)==0)
		then {
			SetCursor(0,Line);
			Application->ProcessMessages();
		}

		S=GetLine(Line);
		if (S.IsEmpty())
		then {
			TagText+=S;
			TagText+="\r\n";
			continue;
		}
		ms=ExtractText(S,text);
		if (text.IsEmpty())
		then {
			TagText+=S;
			TagText+="\r\n";
			continue;
		}
		s=text.LowerCase();
		if ((s.AnsiPos("font="))
			OR (s.AnsiPos("alignment="))
			OR (s.AnsiPos("wordwrap="))
			OR (s.AnsiPos("color="))
			OR (s.AnsiPos("backcolor="))
			OR (s.AnsiPos("#fade"))
			OR (s.AnsiPos("#white")))
		then {
			TagText+=S;
			TagText+="\r\n";
			continue;
		}

		p=text.c_str();
		S="";
		while(*p)
		{
			c=GetChar(p);
			s=CharToStr(c);
			if (SepChr.AnsiPos(s))					//؂蕶iϊȂj
			then {
				S+=s;
				if (c>=0x100)
				then	p+=2;
				else	p++;
				continue;
			}
			if (c=='<')								//<<>ɂij
			then {
				S+="<>";
				p++;
				continue;
			}
			p2=p;
			len=0;
			ChrType=0;
			while(1)
			{
				c2=GetChar(p2);
				if (c2==0)
				then	break;
				if (c2=='<')							//<Ȃ؂
				then	break;
				if (c2>=0x100)
				then	ctype=1;
				else	ctype=0;
				if (ctype != ChrType)					//ipSpjς
				then {
					if (len==0)
					then	ChrType=ctype;
					else	break;
				}
				s2=CharToStr(c2);
				if (SepChr.AnsiPos(s2))					//؂蕶
				then	break;
				if (ctype)
				then {
					p2+=2;
					len+=2;
				}
				else {
					p2++;
					len++;
				}
				if (AnsiPos(s2,SepChr2))				//؂蕶iϊɂ͊܂߂j
				then	break;
			}
			l=len;
			s=(char*)p;
			if (c>=0x100)
			then	n=2;
			else	n=1;
			while(len>n)
			{
				s.SetLength(len);
				i=SList->Text.AnsiPos(s);
				if (i)
				then {
					s1=CharToStr(c);
					crc=CRC32(0,(char*)p,len);
					s1=Format("<%d,%d,%s,0x%x>",OPENARRAY(TVarRec,((i),(len),(s1.c_str()),((int)crc))));
/*
					i=TagText.AnsiPos(s1);
					if (i)
					then {
						s1=Format("<%d,%d>",OPENARRAY(TVarRec,((-i),(s1.Length()))));
					}
*/
					S+=s1;
					p+=len;
					len=-1;
					break;
				}
				p2=s.AnsiLastChar();
				if (LeadBytes.Contains(*p2))
				then	len-=2;
				else	len--;
			}
			if (len>=0)
			then {
/*
				if (l>2)
				then {
					s=(char*)p;
					s.SetLength(l);
					i=TagText.AnsiPos(s);
					if (i)
					then {
						S+=Format("<%d,%d>",OPENARRAY(TVarRec,((-i),(l))));
						p+=l;
						continue;
					}
				}
*/				
				S+=CharToStr(c);
				if (c>=0x100)
				then	p+=2;
				else	p++;
			}
		}
//		Lines[Line]=MakeLine(ms,S);
		TagText+=MakeLine(ms,S);
		TagText+="\r\n";
	}
	Edit->Text=TagText;

	SetCursor(0,0);
	Edit->Invalidate();

	delete	SList;

	FFileName=ChangeFileExt(FFileName,".TagLyr");

	SetCaption(FFileName);

	return(true);
}

/*****	j[J	*****/

void __fastcall TFormMain::MenuOpenClick(TObject *Sender)
{
	OpenDialog->Title="J";
	OpenDialog->FilterIndex=2;
	OpenDialog->FileName="";
	OpenDialog->DefaultExt="lyr";
	if (OpenDialog->Execute())
	then {
		Load(OpenDialog->FileName);							//[h
		OpenDialog->InitialDir=ExtractFileDir(OpenDialog->FileName);
	}
}

/*****	j[J	*****/

void __fastcall TFormMain::MenuReopenClick(TObject *Sender)
{
	if ((FLoadFileName.IsEmpty())
		OR (FileExists(FLoadFileName)==false))
	then	return;

	if (Edit->Modified)
	then {
		AnsiString	S="ҏWj";
		S+=FLoadFileName;
		S+="J܂H";
		if (MessageDlg(S,mtConfirmation,TMsgDlgButtons()<<mbYes<<mbCancel,0)==mrCancel)
		then	return;
	}
	Load(FLoadFileName);
}

/*****	IEŊJĂy[W_E[h	*****/

void __fastcall TFormMain::MenuOpenIEClick(TObject *Sender)
{
	AnsiString	URL=GetBrowserURL();

	if (URL.IsEmpty())
	then {
		MessageDlg("C^[lbgGNXv[[ŉ̎y[W\Ă",mtError,TMsgDlgButtons()<<mbOK,0);
		return;
	}

	URL=ExtractURL(URL);

	if (URL.IsEmpty())
	then	return;

	dsWaitCursor	csr;

	if (URL.AnsiPos("http:"))
	then {
		AnsiString	S=ExtractFilePath(Application->ExeName);
		S+="$Download.htm";

		if (Download(URL,S))
		then {
			Load(S);
			DeleteFile(S);
			SetCaption("");
		}
	}
	else {
		Load(URL);
	}
}

/*****	j[ۑ	*****/

void __fastcall TFormMain::MenuSaveAsClick(TObject *Sender)
{
	SaveDialog->FileName=FFileName;
	if (FFileName.IsEmpty())
	then {
		AnsiString	S=Edit->Lines->Values["Title"];
		if (!S.IsEmpty())
		then {
			S+=".lyr";
			SaveDialog->FileName=S;
		}
	}
	if (AnsiLowerCase(ExtractFileExt(FFileName))==".taglyr")
	then {
		SaveDialog->FilterIndex=2;
		SaveDialog->DefaultExt="TagLyr";
	}
	else {
		SaveDialog->FilterIndex=1;
		SaveDialog->DefaultExt="lyr";
	}

	if (SaveDialog->Execute())
	then {
		Save(SaveDialog->FileName);
		SaveDialog->InitialDir=ExtractFileDir(SaveDialog->FileName);
	}
}

/*****	j[I	*****/

void __fastcall TFormMain::MenuExitClick(TObject *Sender)
{
	Close();
}


/*****	j[`FbN	*****/

void __fastcall TFormMain::CheckMenu(TObject *Sender)
{
	if (Edit->SelLength)
	then {
		MenuCut->Enabled=true;
		MenuCopy->Enabled=true;
		PopupCut->Enabled=true;
		PopupCopy->Enabled=true;
	}
	else {
		MenuCut->Enabled=false;
		MenuCopy->Enabled=false;
		PopupCut->Enabled=false;
		PopupCopy->Enabled=false;
	}
	TClipboard	*cb=Clipboard();
	MenuPaste->Enabled=cb->HasFormat(CF_TEXT);
	PopupPaste->Enabled=MenuPaste->Enabled;

	if (Edit->Lines->IndexOfName("URL")>=0)
	then {
		MenuConvertFromURL->Enabled=true;
		ConvertMenuConvertFromURL->Enabled=true;
		PopupConvertURL->Enabled=true;
	}
	else {
		MenuConvertFromURL->Enabled=false;
		ConvertMenuConvertFromURL->Enabled=false;
		PopupConvertURL->Enabled=false;
	}
}

/*****	؂	*****/

void __fastcall TFormMain::MenuCutClick(TObject *Sender)
{
	Edit->ClearUndo();
	Edit->CutToClipboard();
}

/*****	Rs[	*****/

void __fastcall TFormMain::MenuCopyClick(TObject *Sender)
{
	Edit->CopyToClipboard();
}

/*****	\t	*****/

void __fastcall TFormMain::MenuPasteClick(TObject *Sender)
{
	Edit->ClearUndo();
	Edit->PasteFromClipboard();
}

/*****	ɖ߂	*****/

void __fastcall TFormMain::MenuUndoClick(TObject *Sender)
{
	Edit->Undo();
}

/*****	SđI	*****/

void __fastcall TFormMain::MenuAllSelectClick(TObject *Sender)
{
	Edit->SelectAll();
}

/*****	eLXgDSMP	*****/

void __fastcall TFormMain::MenuTextToDSMPClick(TObject *Sender)
{
	TextToDSMP();
}

/*****	DSMPText	*****/

void __fastcall TFormMain::MenuDSMPToTextClick(TObject *Sender)
{
	DSMPToText();
}

/*****	WinAmpDSMP	*****/

void __fastcall TFormMain::MenuWinAmpToDSMPClick(TObject *Sender)
{
	WinAmpToDSMP();
}

/*****	TagDSMP	*****/

void __fastcall TFormMain::MenuTagToDSMPClick(TObject *Sender)
{
	OpenDialog->Title="̎eLXg";
	OpenDialog->FilterIndex=4;
	OpenDialog->DefaultExt="txt";
	if (OpenDialog->Execute())
	then {
		TagToDSMP(OpenDialog->FileName);
	}
}

/*****	DSMPTag	*****/

void __fastcall TFormMain::MenuDSMPToTagClick(TObject *Sender)
{
	OpenDialog->Title="̎eLXg";
	OpenDialog->FilterIndex=4;
	OpenDialog->DefaultExt="txt";
	if (OpenDialog->Execute())
	then {
		DSMPToTag(OpenDialog->FileName);
	}
}

/*****	EBhEőOʂɂ	*****/

void __fastcall	TFormMain::BringToFront(void)
{
		Application->Minimize();
		Application->Restore();

		inherited::BringToFront();
		BringWindowToTop(Handle);
		SetForegroundWindow(Handle);
		SetActiveWindow(Handle);
}

/*****	̃lbgURL`FbN	*****/

AnsiString __fastcall	TFormMain::CheckUtaNet(AnsiString URL)
{
	if (URL.AnsiPos("//www.uta-net.com/phplib/")==0)
	then	return(URL);

	TWinInet	*WinInet=new TWinInet();
	AnsiString	S;

	WinInet->Open();
	if (WinInet->Connect(URL))
	then {
		S=WinInet->QueryInfo(HTTP_QUERY_STATUS_CODE | HTTP_QUERY_FLAG_NUMBER);
		if (S=="200")
		then {
			WinInet->Close();
			delete	WinInet;
			
			return(URL);
		}
	}
	AnsiString	url=StringReplace(URL,"//www.uta-net.com/phplib/","//www.uta-net.com/members/phplib/",TReplaceFlags());
	if (WinInet->Connect(url))
	then {
		S=WinInet->QueryInfo(HTTP_QUERY_STATUS_CODE | HTTP_QUERY_FLAG_NUMBER);
		if (S=="200")
		then	URL=url;
	}

	WinInet->Close();
	delete	WinInet;

	return(URL);
}

/*****	URLJă^Ot@Cϊ	*****/

void __fastcall TFormMain::MenuConvertFromURLClick(TObject *Sender)
{
	AnsiString	URL=Edit->Lines->Values["URL"];

	if (!URL.IsEmpty())
	then {
		URL=CheckUtaNet(URL);

		OpenURL(URL);

		if (Edit->Text.AnsiPos("[TagLyr]"))
		then	TagToDSMP(URL);
		else	DSMPToTag(URL);

		BringToFront();
	}
}

/*****	IEŊJĂy[WŃ^Ot@Cϊ	*****/

void __fastcall TFormMain::MenuConvertFromIEClick(TObject *Sender)
{
	AnsiString	URL=GetBrowserURL();

	if (URL.IsEmpty())
	then {
		MessageDlg("C^[lbgGNXv[[ŉ̎y[W\Ă",mtError,TMsgDlgButtons()<<mbOK,0);
		return;
	}

	URL=ExtractURL(URL);

	if (Edit->Text.AnsiPos("[TagLyr]"))
	then	TagToDSMP(URL);
	else	DSMPToTag(URL);
}

/*****	I[gRo[g	*****/

void __fastcall TFormMain::MenuConvertAutoClick(TObject *Sender)
{
	AnsiString	URL=Edit->Lines->Values["URL"];

	if (!URL.IsEmpty())
	then	MenuConvertFromURLClick(this);
	else if (Edit->Text.AnsiPos("[TagLyr]"))
	then	MenuTagToDSMPClick(this);
	else if (Edit->Text.AnsiPos("[Spec]"))
	then	MenuDSMPToTagClick(this);
	else if ((Edit->Text.AnsiPos("[[[Music Info]]]"))
		OR (Edit->Text.AnsiPos("[00:")))
	then	WinAmpToDSMP();
	else	TextToDSMP();
}

/*****	HELP	*****/

void __fastcall TFormMain::MenuHelpHelpClick(TObject *Sender)
{
	AnsiString	S=ChangeFileExt(Application->ExeName,".chm");

	ShellExecute(Handle,NULL,S.c_str(),NULL,NULL,SW_SHOWNORMAL);
}

/*****	DELTA SOFT	*****/

void __fastcall TFormMain::MenuDELTASOFTClick(TObject *Sender)
{
	OpenURL("http://www.deltasoft.jp/");
}

/*****	̃}bv	*****/

void __fastcall TFormMain::MenuUtaMapClick(TObject *Sender)
{
	OpenURL("http://www.utamap.com/");
}

/*****	̃lbg	*****/

void __fastcall TFormMain::MenuUtaNetClick(TObject *Sender)
{
	OpenURL("http://www.uta-net.com/");
}


/*****	z[y[W{^	*****/

void __fastcall TFormMain::BtnHomePageClick(TObject *Sender)
{
	BtnHomePage->CheckMenuDropdown();
}

/*****	̎	*****/
/*
	Type=0:Title
	Type=1:Artist
*/
void __fastcall	TFormMain::FindLyrics(int Type)
{
	int				Line;
	AnsiString		S,s;
	AnsiString		Str;
	unsigned char	*p;

	if (Type==1)
	then	Str=Edit->Lines->Values["Artist"];
	else	Str=Edit->Lines->Values["Title"];

	if (Str.IsEmpty())
	then {
		OpenURL("http://www.uta-net.com/");
		OpenURL("http://www.utamap.com/");
		return;
	}

	s=StringReplace(Str," ","+",TReplaceFlags()<<rfReplaceAll);
	S="http://www.utamap.com/search.php?";
	if (Type==0)
	then	S+="searchname=srtitle";
	else	S+="searchname=srartist";
	S+="&inputvalue=";
	S+=s;
	S+="&act=search";
	OpenURL(S);

	S=SJIStoEUC(Str);
	p=S.c_str();
	s="";
	while(*p)
	{
		s+=Format("%%%2X",ARRAYOFCONST(((int)*p)));
		p++;
	}

	S="http://www.uta-net.com/members/phplib/maphp001.php3?cursession=index2&curuserid=pageone&MA_select_ga=";
	if (Type)
	then	S+="%B2%CE%BC%EA%CC%BE";
	else	S+="%B6%CA%CC%BE";
	S+="&MA_text1_de=";
	S+=s;
	S+="&MA_select_kasio=%A4%AC%B4%DE%A4%DE%A4%EC%A4%EB&MA_sousa=%B8%A1%BA%F7";
	OpenURL(S);
}

/*****	Ȗŉ̎	*****/

void __fastcall TFormMain::MenuFindLyricsFromTitleClick(TObject *Sender)
{
	FindLyrics(0);
}


/*****	A[eBXgŉ̎	*****/

void __fastcall TFormMain::MenuFindLyricsFromArtistClick(TObject *Sender)
{
	FindLyrics(1);
}

/*****	URLJ	*****/

void __fastcall TFormMain::MenuOpenURLClick(TObject *Sender)
{
	AnsiString	S=Edit->Lines->Values["URL"];

	if (!S.IsEmpty())
	then {
		S=CheckUtaNet(S);

		OpenURL(S);
	}
}

/*****	̎{^	*****/

void __fastcall TFormMain::BtnFindLyricsClick(TObject *Sender)
{
	BtnFindLyrics->CheckMenuDropdown();
}

/*****	j[NbN	*****/

void __fastcall TFormMain::MenuFindClick(TObject *Sender)
{
	if (Edit->Lines->IndexOfName("URL")>=0)
	then	MenuOpenURL->Enabled=true;
	else	MenuOpenURL->Enabled=false;

	if (Edit->Lines->IndexOfName("Title")>=0)
	then	MenuFindLyricsFromTitle->Enabled=true;
	else	MenuFindLyricsFromTitle->Enabled=false;

	if (Edit->Lines->IndexOfName("Artist")>=0)
	then	MenuFindLyricsFromArtist->Enabled=true;
	else	MenuFindLyricsFromArtist->Enabled=false;

}

/****	j[|bvAbv	*****/

void __fastcall TFormMain::FindMenuPopup(TObject *Sender)
{
	if (Edit->Lines->IndexOfName("URL")>=0)
	then	PopupOpenURL->Enabled=true;
	else	PopupOpenURL->Enabled=false;

	if (Edit->Lines->IndexOfName("Title")>=0)
	then	PopupFindLyricsFromTitle->Enabled=true;
	else	PopupFindLyricsFromTitle->Enabled=false;

	if (Edit->Lines->IndexOfName("Artist")>=0)
	then	PopupFindLyricsFromArtist->Enabled=true;
	else	PopupFindLyricsFromArtist->Enabled=false;

}

/*****	End	*****/

