/*	Filename:Main.h								*/
/************************************************/
/*												*/
/*			DSMP Lyrics Converter				*/
/*												*/
/*			DSMP̎t@Cϊc[			*/
/*												*/
/*					Ver.6.31   					*/
/*												*/
/*		CtH[W[wb_[		*/
/*                             					*/
/*		Copyright 1999,2003 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef mainH
#define mainH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>

#include "html.h"
#include "inet.h"

#define	WM_DSMPLC_CONVERT	(WM_APP+1)

/*----------------------------------------------*/
/*				TFormMainNX					*/
/*----------------------------------------------*/

class TFormMain : public TForm
{
	typedef	TForm	inherited;

__published:	// IDE Ǘ̃R|[lg
	TMainMenu *MainMenu;
	TMenuItem *MenuFile;
	TMenuItem *MenuOpen;
	TMenuItem *MenuSaveAs;
	TMenuItem *MenuExit;
	TMenuItem *N1;
	TOpenDialog *OpenDialog;
	TSaveDialog *SaveDialog;
	TMenuItem *MenuConvert;
	TMenuItem *MenuWinAmpToDSMP;
	TMenuItem *MenuTagToDSMP;
	TMenuItem *MenuDSMPToTag;
	TMenuItem *MenuTextToDSMP;
	TMenuItem *MenuHelp;
	TMenuItem *MenuHelpHelp;
	TMenuItem *N2;
	TMenuItem *MenuDELTASOFT;
	TMenuItem *MenuUtaMap;
	TMenuItem *MenuUtaNet;
	TRichEdit *Edit;
	TToolBar *ToolBar1;
	TImageList *ImageList;
	TToolButton *BtnOpen;
	TToolButton *BtnSaveAs;
	TToolButton *ToolButton3;
	TToolButton *BtnConvert;
	TPopupMenu *ConvertMenu;
	TMenuItem *ConvMenuTextToDSMP;
	TMenuItem *ConvMenuWinAmpToDSMP;
	TMenuItem *ConvMenuTagToDSMP;
	TMenuItem *ConvMenuDSMPToTag;
	TToolButton *ToolButton1;
	TToolButton *BtnHelp;
	TToolButton *BtnHomePage;
	TPopupMenu *HomePageMenu;
	TMenuItem *HPMenuDELTASOFT;
	TMenuItem *HPMenuUtaMap;
	TMenuItem *HPMenuUtaNet;
	TMenuItem *N5;
	TMenuItem *MenuConvertAuto;
	TMenuItem *MenuDSMPToText;
	TMenuItem *ConvMenuDSMPToText;
	TMenuItem *N3;
	TMenuItem *N4;
	TMenuItem *N6;
	TMenuItem *N7;
	TMenuItem *MenuFindLyricsFromTitle;
	TToolButton *BtnFindLyrics;
	TMenuItem *MenuOpenURL;
	TMenuItem *MenuFindLyricsFromArtist;
	TMenuItem *MenuConvertFromIE;
	TMenuItem *ConvertMenuConvertFromIE;
	TMenuItem *MenuAssocTagLyr;
	TMenuItem *N10;
	TMenuItem *MenuSetDSMPTool;
	TToolButton *BtnConvertFromIE;
	TPopupMenu *FindMenu;
	TMenuItem *PopupFindLyricsFromTitle;
	TMenuItem *PopupFindLyricsFromArtist;
	TMenuItem *PopupOpenURL;
	TMenuItem *MenuFind;
	TMenuItem *MenuConvertFromURL;
	TMenuItem *ConvertMenuConvertFromURL;
	TStatusBar *StatusBar;
	TMenuItem *MenuReopen;
	TMenuItem *MenuEdit;
	TMenuItem *MenuCopy;
	TMenuItem *MenuCut;
	TMenuItem *MenuPaste;
	TToolButton *BtnCopy;
	TToolButton *ToolButton4;
	TToolButton *BtnCut;
	TToolButton *BtnPaste;
	TPopupMenu *PopupMenu;
	TMenuItem *PopupCut;
	TMenuItem *PopupCopy;
	TMenuItem *PopupPaste;
	TMenuItem *N8;
	TMenuItem *PopupConvert;
	TMenuItem *PopupConvertURL;
	TMenuItem *PopupConvertIE;
	TMenuItem *N11;
	TMenuItem *MenuAllSelect;
	TMenuItem *MenuUndo;
	TToolButton *BtnUndo;
	TMenuItem *PopupUndo;
	TMenuItem *MenuOpenIE;
	TMenuItem *N9;
	void __fastcall MenuOpenClick(TObject *Sender);
	void __fastcall MenuExitClick(TObject *Sender);
	void __fastcall MenuSaveAsClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall MenuWinAmpToDSMPClick(TObject *Sender);
	void __fastcall MenuTagToDSMPClick(TObject *Sender);
	void __fastcall MenuDSMPToTagClick(TObject *Sender);
	void __fastcall MenuTextToDSMPClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall MenuDELTASOFTClick(TObject *Sender);
	void __fastcall MenuUtaMapClick(TObject *Sender);
	void __fastcall MenuUtaNetClick(TObject *Sender);
	void __fastcall MenuHelpHelpClick(TObject *Sender);
	void __fastcall MenuConvertAutoClick(TObject *Sender);
	void __fastcall MenuDSMPToTextClick(TObject *Sender);
	void __fastcall MenuFindLyricsFromTitleClick(TObject *Sender);
	void __fastcall MenuOpenURLClick(TObject *Sender);
	void __fastcall MenuFindLyricsFromArtistClick(TObject *Sender);
	void __fastcall MenuConvertFromIEClick(TObject *Sender);
	void __fastcall MenuAssocTagLyrClick(TObject *Sender);
	void __fastcall MenuSetDSMPToolClick(TObject *Sender);
	void __fastcall BtnFindLyricsClick(TObject *Sender);
	void __fastcall BtnHomePageClick(TObject *Sender);
	void __fastcall FindMenuPopup(TObject *Sender);
	void __fastcall MenuFindClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall MenuConvertFromURLClick(TObject *Sender);
	void __fastcall MenuReopenClick(TObject *Sender);
	void __fastcall MenuCutClick(TObject *Sender);
	void __fastcall MenuCopyClick(TObject *Sender);
	void __fastcall MenuPasteClick(TObject *Sender);
	void __fastcall MenuUndoClick(TObject *Sender);
	void __fastcall MenuAllSelectClick(TObject *Sender);
	void __fastcall CheckMenu(TObject *Sender);
	void __fastcall MenuOpenIEClick(TObject *Sender);

private:
	AnsiString		FFileName;
	AnsiString		FLoadFileName;
	AnsiString		FRefFileName;
	AnsiString		FOutFileName;
	int				FError;
	bool			FQuote;
	dsvHtml			*FHtml;

protected:
	void __fastcall	WMConvert(TMessage &Msg);
	void __fastcall WMDropFiles(TWMDropFiles& Msg);
	void __fastcall	SetCaption(AnsiString FileName);
	void __fastcall	Load(AnsiString FileName);
	void __fastcall	Save(AnsiString FileName);
	int __fastcall	InsertSpecSection(void);
	TPoint __fastcall	IndexToPoint(int Index);
	int __fastcall	PointToIndex(int x,int y);
	void __fastcall	SetCursor(int x,int y);
	int __fastcall	GetCursorLineNo(void);
	void __fastcall	SetLine(int line,AnsiString S);
	AnsiString __fastcall	GetLine(int line);
	AnsiString __fastcall	GetCursorLine(void);
	int	__fastcall	GetSelectLine(int &From,int &To);
	int __fastcall	ExtractText(AnsiString S,AnsiString &Text);
	int __fastcall	ExtractLine(int n,AnsiString &Time,AnsiString &Text);
	char* __fastcall	SkipSpace(char *p);
	AnsiString __fastcall	CommaToCR(AnsiString S);
	AnsiString __fastcall	QuotedString(AnsiString S);
	AnsiString __fastcall	ExtractQuotedStr(AnsiString S);
	AnsiString __fastcall	ExtractQuotedString(AnsiString Text);
	AnsiString __fastcall	MakeLine(int ms,TStringList *SList);
	AnsiString __fastcall	MakeLine(int ms,AnsiString Text);
	int __fastcall	StrToTime(AnsiString Time);
	AnsiString __fastcall	TimeToStr(int ms);
	void __fastcall	SetTimes(int Step,int add=0);
	AnsiString __fastcall DeleteSpace(AnsiString S);
	void __fastcall DeleteSpace(void);
	void __fastcall	TextToDSMP(void);
	void __fastcall	DSMPToText(void);
	void __fastcall	WinAmpToDSMP(void);
	bool __fastcall	CheckLinkString(AnsiString S,int len,int sc,unsigned long crc);
	AnsiString __fastcall	FindText(AnsiString Text,int n,int Len,AnsiString s1,unsigned long crc);
	bool __fastcall	TagToDSMP(AnsiString Reference);
	bool __fastcall	DSMPToTag(AnsiString Reference);
	void __fastcall	FindLyrics(int Type);
	AnsiString __fastcall	GetURL(AnsiString URL);
	void __fastcall	DownloadOnProgress(System::TObject* Sender,TDownloadStatus Status,DWORD Size);
																//Ver.6.11
	bool __fastcall	Download(AnsiString URL,AnsiString Path);
	void __fastcall	LoadHtml(AnsiString FileName);
																//Ver.6.13
	void __fastcall	BringToFront(void);
																//Ver.6.14
	AnsiString __fastcall	CheckUtaNet(AnsiString URL);

public:
	__fastcall TFormMain(TComponent* Owner);
	void __fastcall CreateParams(Controls::TCreateParams &Params);

	__property	AnsiString	Lines[int line]={read=GetLine,write=SetLine};

BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
	MESSAGE_HANDLER(WM_DSMPLC_CONVERT, TMessage, WMConvert)
END_MESSAGE_MAP(TScrollingWinControl)
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

extern PACKAGE TFormMain *FormMain;

#endif

/*****	End	*****/

