/*	Filename:HTML.H								*/
/************************************************/
/*												*/
/*			DSMP Lyrics Converter				*/
/*												*/
/*					Ver.6.00  					*/
/*												*/
/*	 			HTMLNXW[			*/
/*                             					*/
/*		Copyright 1998-2002 by DELTA SOFT		*/
/*												*/
/************************************************/

/*----------------------------------------------*/
/*							`					*/
/*----------------------------------------------*/

#ifndef htmlH
#define htmlH

#include	<vcl.h>

enum	TCodeSet	{csUnknown,csSJIS,csEUC,csJIS};

/*----------------------------------------------*/
/*					֐	 					*/
/*----------------------------------------------*/

HANDLE	__fastcall	ExecProcess(AnsiString Path,AnsiString CmdLine,WORD Show,AnsiString OutFileName,int wait,DWORD *ExitCode);

/*----------------------------------------------*/
/*				dsvHtmlNX  					*/
/*----------------------------------------------*/

class	dsvHtml:public TObject
{
private:
	TFileStream	*FFile;
	AnsiString	FFileName;
	AnsiString	FTitle;
	AnsiString	FBackGround;
	AnsiString	FGenerator;
	bool		FEmptySpace;
	TCodeSet	FCodeSet;
	TCodeSet	FPreCodeSet;
	TColor		FBGColor;
	AnsiString	FEditor;

protected:
	void __fastcall	SetFileName(AnsiString S);
	int __fastcall	GetHandle(void);
	int __fastcall	GetPosition(void);
	TCodeSet __fastcall	GetCodeSet(void);

public:
	__fastcall	dsvHtml(void);
	__fastcall	dsvHtml(AnsiString FileName,Word Mode=fmOpenReadWrite);
	__fastcall	~dsvHtml();
	void _fastcall	Open(Word Mode=fmOpenReadWrite);
	void __fastcall	Close(void);
	bool __fastcall	IsEof(void);
	int __fastcall	Seek(int Pos);
	AnsiString __fastcall	Read(void);
	AnsiString __fastcall	Reads(void);
	void __fastcall	Write(AnsiString S);
	void __fastcall	Writes(AnsiString S);
	void __fastcall	WriteTab(int n);
	void __fastcall	Load(AnsiString FileName,TStringList *SList);
	void __fastcall	Save(AnsiString FileName,TStringList *SList);
	void __fastcall	SaveText(AnsiString FileName,TStringList *SList);
	void __fastcall	MakeHeader(void);
	void __fastcall	MakeEnd(void);
	void __fastcall	MakeHTML(void);
	AnsiString __fastcall	ExpandNameEntity(AnsiString S);
	AnsiString __fastcall	ConvertNameEntity(AnsiString S);
	void __fastcall	Edit(void);
	AnsiString __fastcall	GetTitle(void);
	AnsiString __fastcall	GetTarget(AnsiString S,AnsiString Key);
	void __fastcall	GetLink(TStringList *SList);
	void __fastcall	ConvertCode(TCodeSet NewCode,AnsiString Path);

	__property	AnsiString	FileName={read=FFileName,write=SetFileName};
	__property	TFileStream	*File={read=FFile};
	__property	int		Handle={read=GetHandle};
	__property	int		Position={read=GetPosition,write=Seek};
	__property	AnsiString	Title={read=GetTitle,write=FTitle};
	__property	bool	EmptySpace={read=FEmptySpace,write=FEmptySpace};
	__property	AnsiString	BackGround={read=FBackGround,write=FBackGround};
	__property	AnsiString	Generator={read=FGenerator,write=FGenerator};
	__property	TCodeSet	CodeSet={read=GetCodeSet,write=FCodeSet};
	__property	TColor		BGColor={read=FBGColor,write=FBGColor};
	__property	AnsiString	Editor={read=FEditor,write=FEditor};
};

/*----------------------------------------------*/
/*				O[oϐ					*/
/*----------------------------------------------*/

extern	int	Version;


#endif

/*****	End	*****/